#property copyright "Copyright  2007, Forex Profit Monster"
#property link      "http://www.forexprofitmonster.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 DarkGreen
#property indicator_color3 Maroon
#property indicator_color4 Red
#property indicator_width1 5

int g_period_76 = 13;
int g_period_80 = 34;
double g_ibuf_84[];
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];

int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(0, g_ibuf_84);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(1, g_ibuf_88);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(2, g_ibuf_92);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(3, g_ibuf_96);
   IndicatorDigits(Digits + 1);
   string ls_0 = "Profit Monster Slow Trend (" + g_period_76 + "," + g_period_80 + ")";
   IndicatorShortName(ls_0);
   SetIndexLabel(0, ls_0);
   SetIndexLabel(1, ls_0);
   SetIndexLabel(2, ls_0);
   SetIndexLabel(3, ls_0);
   return (0);
}

int start() {
   double ld_12;
   string ls_0 = "2037.08.01";
   int l_str2time_8 = StrToTime(ls_0);
   if (TimeCurrent() >= l_str2time_8) {
      Alert("Trial version has expired! Email support@forexprofitmonster.com with broker account number for rights to full version!");
      return (0);
   }
   int l_ind_counted_20 = IndicatorCounted();
   if (l_ind_counted_20 < 0) return (-1);
   for (int li_24 = Bars - Max(l_ind_counted_20 - 1, 1); li_24 >= 0; li_24--) {
      ld_12 = iMA(NULL, 0, g_period_76, 0, MODE_EMA, PRICE_MEDIAN, li_24) - iMA(NULL, 0, g_period_80, 0, MODE_EMA, PRICE_MEDIAN, li_24);
      if (ld_12 > 0.0) {
         if ((g_ibuf_84[li_24 + 1] != 0.0 && ld_12 >= g_ibuf_84[li_24 + 1]) || (g_ibuf_88[li_24 + 1] != 0.0 && ld_12 > g_ibuf_88[li_24 + 1])) {
            g_ibuf_84[li_24] = ld_12;
            g_ibuf_88[li_24] = 0;
         } else {
            g_ibuf_84[li_24] = 0;
            g_ibuf_88[li_24] = ld_12;
         }
      } else {
         if ((g_ibuf_92[li_24 + 1] != 0.0 && ld_12 >= g_ibuf_92[li_24 + 1]) || (g_ibuf_96[li_24 + 1] != 0.0 && ld_12 > g_ibuf_96[li_24 + 1])) {
            g_ibuf_92[li_24] = ld_12;
            g_ibuf_96[li_24] = 0;
         } else {
            g_ibuf_92[li_24] = 0;
            g_ibuf_96[li_24] = ld_12;
         }
      }
   }
   return (0);
}

int Max(int ai_0, int ai_4) {
   if (ai_0 > ai_4) return (ai_0);
   return (ai_4);
}